##############################################################################
#
# CutImageField - Field that cut Images for Archetypes
# Copyright (C) 2005 atReal
# Based on ImageField
# Copyright (C) 2005 Klein & Partner KEG
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
##############################################################################


#unit test CutImageField

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))


import unittest
from Testing import ZopeTestCase
from Products.CMFPlone.tests import PloneTestCase
from Products.CutImageField.tests.util import PACKAGE_HOME
import PIL.Image as Image
from cStringIO import StringIO

ZopeTestCase.installProduct('Archetypes')
ZopeTestCase.installProduct('CutImageField')

img_file = open(os.path.join(PACKAGE_HOME, 'input', 'original_size.jpg'))
img_content = img_file.read()

res_img_file = open(os.path.join(PACKAGE_HOME, 'output', 'result_size.jpg'))
res_img_content = res_img_file.read()

res_img_mini_file = open(os.path.join(PACKAGE_HOME,'output','result_mini_size.jpg'))
res_img_mini_content = res_img_mini_file.read()

class CutImageFieldTest(PloneTestCase.PloneTestCase):

    def afterSetUp(self):
        from Products.CutImageField import CutImageField
        self.field = CutImageField('cutimage')
        self.folder.validate_field = lambda *args, **kwargs: None
        self.field.original_size=(451,277)
	self.field.sizes={'mini':(99,143)}
        self.field.cut={'original_size':1,
	                'mini':1}

    def test_rescaleOriginal(self):
        value = self.field.rescaleOriginal(img_content)
	self.assertEqual(value,res_img_content,msg="Output image is not as expected in tests/output")

	
def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(CutImageFieldTest))
    return suite

if __name__ == '__main__':
    framework()
